# [RUST GYM](http://rustgym.com) Rust Solutions [![Docs Status](https://docs.rs/rustgym/badge.svg)](https://docs.rs/rustgym) [![Rust](https://github.com/warycat/rustgym/workflows/Rust/badge.svg)](https://github.com/warycat/rustgym/actions)

## [Leetcode Solutions in Rust](#leetcode)
## [AdventOfCode Solutions in Rust](#adventofcode)
## [Google Solutions in Rust](#google)

This project demostrates how to create **Data Structures** and to implement **Algorithms** using programming language **Rust**
All the solutions here are crafted with love and their performance beats 99% of other solutions on the leetcode website. Tutorial videos will be added later.

### Please subscribe to our [RUST GYM Youtube Channel](https://www.youtube.com/channel/UCV9HzRLPKjI8SttaIYOygsw) for future videos.

<details><summary>Data Structures</summary>

- Stack & Queue ( Vec, VecDeque )
- Linked List ( Option<Box<ListNode>> )
- Hash Tables ( HashMap, HashSet )
- Tree Tables ( BTreeMap, BTreeSet )
- Binary Search Tree ( Option<Rc<RefCell<TreeNode>>> )
- Binary Heaps & Priority Queue ( BinaryHeap )
- Graphs ( Vec<Vec<usize>> )
- Union Find ( UnionFind )
- Trie ( Trie )
</details>

<details><summary>Algorithms</summary>

- Bit Manipulation & Numbers
- Stability in Sorting
- Heapsort
- Binary Search
- Kth Smallest Elements
- Permutations
- Subsets
- BFS Graph
- DFS Graph
- Dijkstra’s Algorithm
- Tree Traversals
  - BFS
  - DFS
    - in-order
    - pre-order
    - post-order
- Topological Sort
- Detect cycle in an undirected graph
- Detect a cycle in a directed graph
- Count connected components in a graph
- Find strongly connected components in a graph
</details>

<table id="leetcode" class="table-auto">
  <thead>
    <tr>
      <th>id</th>
      <th>Leetcode</th>
      <th>Level</th>
    </tr>
  </thead>
  <tbody>
      <tr>
        <td>
          1
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1"> Two Sum</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          7
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/7"> Reverse Integer</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          9
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/9"> Palindrome Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          13
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/13"> Roman to Integer</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          14
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/14"> Longest Common Prefix</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          20
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/20"> Valid Parentheses</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          21
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/21"> Merge Two Sorted Lists</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          26
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/26"> Remove Duplicates from Sorted Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          27
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/27"> Remove Element</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          28
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/28"> Implement strStr()</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          35
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/35"> Search Insert Position</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          53
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/53"> Maximum Subarray</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          58
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/58"> Length of Last Word</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          66
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/66"> Plus One</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          67
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/67"> Add Binary</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          69
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/69"> Sqrt(x)</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          70
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/70"> Climbing Stairs</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          83
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/83"> Remove Duplicates from Sorted List</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          88
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/88"> Merge Sorted Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          100
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/100"> Same Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          101
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/101"> Symmetric Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          104
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/104"> Maximum Depth of Binary Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          108
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/108"> Convert Sorted Array to Binary Search Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          110
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/110"> Balanced Binary Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          111
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/111"> Minimum Depth of Binary Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          112
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/112"> Path Sum</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          118
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/118"> Pascal&#x27;s Triangle</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          119
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/119"> Pascal&#x27;s Triangle II</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          121
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/121"> Best Time to Buy and Sell Stock</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          122
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/122"> Best Time to Buy and Sell Stock II</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          125
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/125"> Valid Palindrome</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          136
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/136"> Single Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          141
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/141"> Linked List Cycle</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          155
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/155"> Min Stack</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          157
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/157"> Read N Characters Given Read4</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          160
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/160"> Intersection of Two Linked Lists</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          163
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/163"> Missing Ranges</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          167
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/167"> Two Sum II - Input array is sorted</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          168
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/168"> Excel Sheet Column Title</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          169
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/169"> Majority Element</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          170
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/170"> Two Sum III - Data structure design</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          171
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/171"> Excel Sheet Column Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          172
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/172"> Factorial Trailing Zeroes</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          190
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/190"> Reverse Bits</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          191
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/191"> Number of 1 Bits</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          202
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/202"> Happy Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          203
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/203"> Remove Linked List Elements</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          204
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/204"> Count Primes</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          205
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/205"> Isomorphic Strings</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          206
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/206"> Reverse Linked List</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          217
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/217"> Contains Duplicate</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          219
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/219"> Contains Duplicate II</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          225
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/225"> Implement Stack using Queues</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          226
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/226"> Invert Binary Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          228
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/228"> Summary Ranges</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          231
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/231"> Power of Two</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          232
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/232"> Implement Queue using Stacks</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          234
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/234"> Palindrome Linked List</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          235
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/235"> Lowest Common Ancestor of a Binary Search Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          237
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/237"> Delete Node in a Linked List</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          242
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/242"> Valid Anagram</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          243
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/243"> Shortest Word Distance</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          246
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/246"> Strobogrammatic Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          252
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/252"> Meeting Rooms</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          257
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/257"> Binary Tree Paths</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          258
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/258"> Add Digits</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          263
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/263"> Ugly Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          266
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/266"> Palindrome Permutation</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          268
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/268"> Missing Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          270
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/270"> Closest Binary Search Tree Value</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          278
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/278"> First Bad Version</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          283
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/283"> Move Zeroes</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          290
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/290"> Word Pattern</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          292
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/292"> Nim Game</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          293
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/293"> Flip Game</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          303
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/303"> Range Sum Query - Immutable</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          326
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/326"> Power of Three</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          342
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/342"> Power of Four</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          344
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/344"> Reverse String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          345
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/345"> Reverse Vowels of a String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          346
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/346"> Moving Average from Data Stream</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          349
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/349"> Intersection of Two Arrays</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          350
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/350"> Intersection of Two Arrays II</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          359
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/359"> Logger Rate Limiter</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          367
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/367"> Valid Perfect Square</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          374
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/374"> Guess Number Higher or Lower</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          383
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/383"> Ransom Note</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          387
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/387"> First Unique Character in a String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          389
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/389"> Find the Difference</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          392
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/392"> Is Subsequence</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          401
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/401"> Binary Watch</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          404
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/404"> Sum of Left Leaves</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          405
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/405"> Convert a Number to Hexadecimal</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          408
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/408"> Valid Word Abbreviation</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          409
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/409"> Longest Palindrome</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          412
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/412"> Fizz Buzz</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          414
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/414"> Third Maximum Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          415
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/415"> Add Strings</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          422
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/422"> Valid Word Square</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          434
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/434"> Number of Segments in a String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          441
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/441"> Arranging Coins</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          448
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/448"> Find All Numbers Disappeared in an Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          453
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/453"> Minimum Moves to Equal Array Elements</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          455
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/455"> Assign Cookies</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          459
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/459"> Repeated Substring Pattern</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          461
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/461"> Hamming Distance</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          463
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/463"> Island Perimeter</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          476
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/476"> Number Complement</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          482
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/482"> License Key Formatting</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          485
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/485"> Max Consecutive Ones</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          492
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/492"> Construct the Rectangle</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          496
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/496"> Next Greater Element I</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          500
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/500"> Keyboard Row</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          501
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/501"> Find Mode in Binary Search Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          504
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/504"> Base 7</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          506
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/506"> Relative Ranks</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          507
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/507"> Perfect Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          509
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/509"> Fibonacci Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          520
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/520"> Detect Capital</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          521
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/521"> Longest Uncommon Subsequence I</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          530
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/530"> Minimum Absolute Difference in BST</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          541
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/541"> Reverse String II</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          543
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/543"> Diameter of Binary Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          551
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/551"> Student Attendance Record I</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          557
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/557"> Reverse Words in a String III</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          559
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/559"> Maximum Depth of N-ary Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          561
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/561"> Array Partition I</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          563
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/563"> Binary Tree Tilt</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          566
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/566"> Reshape the Matrix</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          572
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/572"> Subtree of Another Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          575
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/575"> Distribute Candies</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          589
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/589"> N-ary Tree Preorder Traversal</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          590
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/590"> N-ary Tree Postorder Traversal</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          594
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/594"> Longest Harmonious Subsequence</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          598
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/598"> Range Addition II</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          599
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/599"> Minimum Index Sum of Two Lists</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          604
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/604"> Design Compressed String Iterator</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          605
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/605"> Can Place Flowers</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          606
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/606"> Construct String from Binary Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          617
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/617"> Merge Two Binary Trees</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          628
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/628"> Maximum Product of Three Numbers</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          637
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/637"> Average of Levels in Binary Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          643
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/643"> Maximum Average Subarray I</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          645
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/645"> Set Mismatch</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          653
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/653"> Two Sum IV - Input is a BST</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          657
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/657"> Robot Return to Origin</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          661
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/661"> Image Smoother</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          671
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/671"> Second Minimum Node In a Binary Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          674
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/674"> Longest Continuous Increasing Subsequence</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          680
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/680"> Valid Palindrome II</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          682
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/682"> Baseball Game</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          690
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/690"> Employee Importance</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          693
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/693"> Binary Number with Alternating Bits</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          696
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/696"> Count Binary Substrings</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          697
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/697"> Degree of an Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          700
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/700"> Search in a Binary Search Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          703
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/703"> Kth Largest Element in a Stream</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          704
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/704"> Binary Search</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          705
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/705"> Design HashSet</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          706
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/706"> Design HashMap</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          709
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/709"> To Lower Case</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          716
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/716"> Max Stack</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          717
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/717"> 1-bit and 2-bit Characters</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          720
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/720"> Longest Word in Dictionary</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          724
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/724"> Find Pivot Index</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          728
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/728"> Self Dividing Numbers</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          733
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/733"> Flood Fill</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          734
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/734"> Sentence Similarity</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          744
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/744"> Find Smallest Letter Greater Than Target</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          746
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/746"> Min Cost Climbing Stairs</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          747
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/747"> Largest Number At Least Twice of Others</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          748
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/748"> Shortest Completing Word</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          758
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/758"> Bold Words in String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          760
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/760"> Find Anagram Mappings</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          762
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/762"> Prime Number of Set Bits in Binary Representation</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          766
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/766"> Toeplitz Matrix</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          771
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/771"> Jewels and Stones</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          783
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/783"> Minimum Distance Between BST Nodes</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          788
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/788"> Rotated Digits</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          796
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/796"> Rotate String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          800
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/800"> Similar RGB Color</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          804
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/804"> Unique Morse Code Words</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          806
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/806"> Number of Lines To Write String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          811
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/811"> Subdomain Visit Count</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          812
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/812"> Largest Triangle Area</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          819
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/819"> Most Common Word</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          821
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/821"> Shortest Distance to a Character</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          824
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/824"> Goat Latin</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          830
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/830"> Positions of Large Groups</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          832
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/832"> Flipping an Image</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          836
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/836"> Rectangle Overlap</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          844
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/844"> Backspace String Compare</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          852
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/852"> Peak Index in a Mountain Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          859
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/859"> Buddy Strings</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          860
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/860"> Lemonade Change</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          867
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/867"> Transpose Matrix</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          868
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/868"> Binary Gap</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          872
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/872"> Leaf-Similar Trees</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          874
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/874"> Walking Robot Simulation</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          876
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/876"> Middle of the Linked List</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          883
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/883"> Projection Area of 3D Shapes</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          884
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/884"> Uncommon Words from Two Sentences</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          888
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/888"> Fair Candy Swap</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          892
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/892"> Surface Area of 3D Shapes</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          893
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/893"> Groups of Special-Equivalent Strings</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          896
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/896"> Monotonic Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          897
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/897"> Increasing Order Search Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          905
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/905"> Sort Array By Parity</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          908
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/908"> Smallest Range I</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          914
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/914"> X of a Kind in a Deck of Cards</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          917
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/917"> Reverse Only Letters</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          922
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/922"> Sort Array By Parity II</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          925
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/925"> Long Pressed Name</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          929
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/929"> Unique Email Addresses</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          933
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/933"> Number of Recent Calls</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          937
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/937"> Reorder Data in Log Files</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          938
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/938"> Range Sum of BST</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          941
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/941"> Valid Mountain Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          942
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/942"> DI String Match</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          944
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/944"> Delete Columns to Make Sorted</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          953
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/953"> Verifying an Alien Dictionary</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          961
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/961"> N-Repeated Element in Size 2N Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          965
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/965"> Univalued Binary Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          976
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/976"> Largest Perimeter Triangle</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          977
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/977"> Squares of a Sorted Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          985
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/985"> Sum of Even Numbers After Queries</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          989
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/989"> Add to Array-Form of Integer</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          993
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/993"> Cousins in Binary Tree</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          997
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/997"> Find the Town Judge</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          999
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/999"> Available Captures for Rook</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1002
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1002"> Find Common Characters</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1005
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1005"> Maximize Sum Of Array After K Negations</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1009
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1009"> Complement of Base 10 Integer</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1013
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1013"> Partition Array Into Three Parts With Equal Sum</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1018
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1018"> Binary Prefix Divisible By 5</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1021
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1021"> Remove Outermost Parentheses</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1022
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1022"> Sum of Root To Leaf Binary Numbers</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1025
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1025"> Divisor Game</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1030
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1030"> Matrix Cells in Distance Order</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1033
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1033"> Moving Stones Until Consecutive</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1037
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1037"> Valid Boomerang</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1046
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1046"> Last Stone Weight</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1047
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1047"> Remove All Adjacent Duplicates In String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1051
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1051"> Height Checker</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1056
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1056"> Confusing Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1064
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1064"> Fixed Point</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1065
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1065"> Index Pairs of a String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1071
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1071"> Greatest Common Divisor of Strings</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1078
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1078"> Occurrences After Bigram</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1085
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1085"> Sum of Digits in the Minimum Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1086
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1086"> High Five</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1089
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1089"> Duplicate Zeros</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1099
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1099"> Two Sum Less Than K</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1103
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1103"> Distribute Candies to People</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1108
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1108"> Defanging an IP Address</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1118
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1118"> Number of Days in a Month</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1119
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1119"> Remove Vowels from a String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1122
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1122"> Relative Sort Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1128
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1128"> Number of Equivalent Domino Pairs</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1133
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1133"> Largest Unique Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1134
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1134"> Armstrong Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1137
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1137"> N-th Tribonacci Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1150
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1150"> Check If a Number Is Majority Element in a Sorted Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1154
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1154"> Day of the Year</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1160
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1160"> Find Words That Can Be Formed by Characters</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1165
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1165"> Single-Row Keyboard</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1175
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1175"> Prime Arrangements</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1176
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1176"> Diet Plan Performance</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1180
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1180"> Count Substrings with Only One Distinct Letter</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1184
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1184"> Distance Between Bus Stops</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1185
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1185"> Day of the Week</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1189
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1189"> Maximum Number of Balloons</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1196
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1196"> How Many Apples Can You Put into the Basket</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1200
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1200"> Minimum Absolute Difference</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1207
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1207"> Unique Number of Occurrences</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1213
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1213"> Intersection of Three Sorted Arrays</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1217
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1217"> Minimum Cost to Move Chips to The Same Position</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1221
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1221"> Split a String in Balanced Strings</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1228
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1228"> Missing Number In Arithmetic Progression</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1232
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1232"> Check If It Is a Straight Line</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1243
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1243"> Array Transformation</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1252
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1252"> Cells with Odd Values in a Matrix</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1260
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1260"> Shift 2D Grid</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1266
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1266"> Minimum Time Visiting All Points</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1271
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1271"> Hexspeak</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1275
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1275"> Find Winner on a Tic Tac Toe Game</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1281
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1281"> Subtract the Product and Sum of Digits of an Integer</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1287
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1287"> Element Appearing More Than 25% In Sorted Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1290
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1290"> Convert Binary Number in a Linked List to Integer</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1295
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1295"> Find Numbers with Even Number of Digits</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1299
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1299"> Replace Elements with Greatest Element on Right Side</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1304
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1304"> Find N Unique Integers Sum up to Zero</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1309
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1309"> Decrypt String from Alphabet to Integer Mapping</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1313
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1313"> Decompress Run-Length Encoded List</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1317
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1317"> Convert Integer to the Sum of Two No-Zero Integers</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1323
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1323"> Maximum 69 Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1331
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1331"> Rank Transform of an Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1332
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1332"> Remove Palindromic Subsequences</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1337
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1337"> The K Weakest Rows in a Matrix</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1342
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1342"> Number of Steps to Reduce a Number to Zero</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1346
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1346"> Check If N and Its Double Exist</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1351
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1351"> Count Negative Numbers in a Sorted Matrix</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1356
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1356"> Sort Integers by The Number of 1 Bits</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1360
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1360"> Number of Days Between Two Dates</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1365
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1365"> How Many Numbers Are Smaller Than the Current Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1370
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1370"> Increasing Decreasing String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1374
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1374"> Generate a String With Characters That Have Odd Counts</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1380
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1380"> Lucky Numbers in a Matrix</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1385
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1385"> Find the Distance Value Between Two Arrays</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1389
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1389"> Create Target Array in the Given Order</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1394
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1394"> Find Lucky Integer in an Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1399
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1399"> Count Largest Group</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1403
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1403"> Minimum Subsequence in Non-Increasing Order</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1408
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1408"> String Matching in an Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1413
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1413"> Minimum Value to Get Positive Step by Step Sum</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1417
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1417"> Reformat The String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1422
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1422"> Maximum Score After Splitting a String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1426
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1426"> Counting Elements</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1427
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1427"> Perform String Shifts</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1431
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1431"> Kids With the Greatest Number of Candies</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1436
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1436"> Destination City</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1437
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1437"> Check If All 1&#x27;s Are at Least Length K Places Away</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1441
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1441"> Build an Array With Stack Operations</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1446
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1446"> Consecutive Characters</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1450
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1450"> Number of Students Doing Homework at a Given Time</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1455
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1455"> Check If a Word Occurs As a Prefix of Any Word in a Sentence</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1460
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1460"> Make Two Arrays Equal by Reversing Sub-arrays</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1464
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1464"> Maximum Product of Two Elements in an Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1469
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1469"> Find All The Lonely Nodes</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1470
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1470"> Shuffle the Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1474
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1474"> Delete N Nodes After M Nodes of a Linked List</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1475
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1475"> Final Prices With a Special Discount in a Shop</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1480
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1480"> Running Sum of 1d Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1486
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1486"> XOR Operation in an Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1491
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1491"> Average Salary Excluding the Minimum and Maximum Salary</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1496
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1496"> Path Crossing</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1502
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1502"> Can Make Arithmetic Progression From Sequence</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1507
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1507"> Reformat Date</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1512
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1512"> Number of Good Pairs</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1518
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1518"> Water Bottles</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1523
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1523"> Count Odd Numbers in an Interval Range</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1528
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1528"> Shuffle String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1534
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1534"> Count Good Triplets</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1539
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1539"> Kth Missing Positive Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1544
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1544"> Make The String Great</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1550
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1550"> Three Consecutive Odds</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1556
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1556"> Thousand Separator</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1560
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1560"> Most Visited Sector in  a Circular Track</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1566
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1566"> Detect Pattern of Length M Repeated K or More Times</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1572
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1572"> Matrix Diagonal Sum</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1576
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1576"> Replace All ?&#x27;s to Avoid Consecutive Repeating Characters</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1582
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1582"> Special Positions in a Binary Matrix</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1588
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1588"> Sum of All Odd Length Subarrays</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1592
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1592"> Rearrange Spaces Between Words</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1598
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1598"> Crawler Log Folder</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1603
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1603"> Design Parking System</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1608
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1608"> Special Array With X Elements Greater Than or Equal X</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1614
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1614"> Maximum Nesting Depth of the Parentheses</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1619
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1619"> Mean of Array After Removing Some Elements</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1624
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1624"> Largest Substring Between Two Equal Characters</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1629
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1629"> Slowest Key</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1636
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1636"> Sort Array by Increasing Frequency</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1640
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1640"> Check Array Formation Through Concatenation</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1646
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1646"> Get Maximum in Generated Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1652
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1652"> Defuse the Bomb</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1656
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1656"> Design an Ordered Stream</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1662
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1662"> Check If Two String Arrays are Equivalent</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1668
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1668"> Maximum Repeating Substring</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1672
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1672"> Richest Customer Wealth</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1678
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1678"> Goal Parser Interpretation</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1684
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1684"> Count the Number of Consistent Strings</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1688
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1688"> Count of Matches in Tournament</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1694
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1694"> Reformat Phone Number</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1700
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1700"> Number of Students Unable to Eat Lunch</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1704
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1704"> Determine if String Halves Are Alike</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1708
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1708"> Largest Subarray Length K</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1710
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1710"> Maximum Units on a Truck</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1716
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1716"> Calculate Money in Leetcode Bank</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1720
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1720"> Decode XORed Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1725
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1725"> Number Of Rectangles That Can Form The Largest Square</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1732
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1732"> Find the Highest Altitude</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1736
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1736"> Latest Time by Replacing Hidden Digits</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1742
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1742"> Maximum Number of Balls in a Box</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1748
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1748"> Sum of Unique Elements</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1752
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1752"> Check if Array Is Sorted and Rotated</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1758
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1758"> Minimum Changes To Make Alternating Binary String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1763
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1763"> Longest Nice Substring</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1768
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1768"> Merge Strings Alternately</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1773
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1773"> Count Items Matching a Rule</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1779
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1779"> Find Nearest Point That Has the Same X or Y Coordinate</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1784
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1784"> Check if Binary String Has at Most One Segment of Ones</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1790
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1790"> Check if One String Swap Can Make Strings Equal</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1796
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1796"> Second Largest Digit in a String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1800
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1800"> Maximum Ascending Subarray Sum</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1805
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1805"> Number of Different Integers in a String</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1812
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1812"> Determine Color of a Chessboard Square</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1816
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1816"> Truncate Sentence</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1822
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1822"> Sign of the Product of an Array</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1826
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1826"> Faulty Sensor</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1827
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1827"> Minimum Operations to Make the Array Increasing</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          1832
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1832"> Check if the Sentence Is Pangram</a>
        </td>
        <td>Easy</td>
      </tr>
      <tr>
        <td>
          2
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/2"> Add Two Numbers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          3
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/3"> Longest Substring Without Repeating Characters</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          5
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/5"> Longest Palindromic Substring</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          6
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/6"> ZigZag Conversion</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          8
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/8"> String to Integer (atoi)</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          11
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/11"> Container With Most Water</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          12
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/12"> Integer to Roman</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          15
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/15"> 3Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          16
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/16"> 3Sum Closest</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          17
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/17"> Letter Combinations of a Phone Number</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          18
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/18"> 4Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          19
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/19"> Remove Nth Node From End of List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          22
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/22"> Generate Parentheses</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          24
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/24"> Swap Nodes in Pairs</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          29
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/29"> Divide Two Integers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          31
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/31"> Next Permutation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          33
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/33"> Search in Rotated Sorted Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          34
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/34"> Find First and Last Position of Element in Sorted Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          36
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/36"> Valid Sudoku</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          38
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/38"> Count and Say</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          39
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/39"> Combination Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          40
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/40"> Combination Sum II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          43
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/43"> Multiply Strings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          45
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/45"> Jump Game II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          46
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/46"> Permutations</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          47
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/47"> Permutations II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          48
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/48"> Rotate Image</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          49
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/49"> Group Anagrams</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          50
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/50"> Pow(x, n)</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          54
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/54"> Spiral Matrix</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          55
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/55"> Jump Game</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          56
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/56"> Merge Intervals</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          57
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/57"> Insert Interval</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          59
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/59"> Spiral Matrix II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          61
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/61"> Rotate List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          62
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/62"> Unique Paths</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          63
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/63"> Unique Paths II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          64
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/64"> Minimum Path Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          71
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/71"> Simplify Path</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          73
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/73"> Set Matrix Zeroes</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          74
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/74"> Search a 2D Matrix</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          75
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/75"> Sort Colors</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          77
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/77"> Combinations</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          78
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/78"> Subsets</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          79
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/79"> Word Search</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          80
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/80"> Remove Duplicates from Sorted Array II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          81
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/81"> Search in Rotated Sorted Array II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          82
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/82"> Remove Duplicates from Sorted List II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          86
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/86"> Partition List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          89
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/89"> Gray Code</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          90
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/90"> Subsets II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          91
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/91"> Decode Ways</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          92
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/92"> Reverse Linked List II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          93
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/93"> Restore IP Addresses</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          94
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/94"> Binary Tree Inorder Traversal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          95
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/95"> Unique Binary Search Trees II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          96
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/96"> Unique Binary Search Trees</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          97
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/97"> Interleaving String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          98
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/98"> Validate Binary Search Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          102
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/102"> Binary Tree Level Order Traversal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          103
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/103"> Binary Tree Zigzag Level Order Traversal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          105
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/105"> Construct Binary Tree from Preorder and Inorder Traversal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          106
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/106"> Construct Binary Tree from Inorder and Postorder Traversal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          107
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/107"> Binary Tree Level Order Traversal II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          109
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/109"> Convert Sorted List to Binary Search Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          113
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/113"> Path Sum II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          114
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/114"> Flatten Binary Tree to Linked List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          116
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/116"> Populating Next Right Pointers in Each Node</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          117
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/117"> Populating Next Right Pointers in Each Node II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          120
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/120"> Triangle</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          129
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/129"> Sum Root to Leaf Numbers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          130
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/130"> Surrounded Regions</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          131
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/131"> Palindrome Partitioning</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          133
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/133"> Clone Graph</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          134
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/134"> Gas Station</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          137
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/137"> Single Number II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          138
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/138"> Copy List with Random Pointer</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          139
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/139"> Word Break</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          142
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/142"> Linked List Cycle II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          143
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/143"> Reorder List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          144
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/144"> Binary Tree Preorder Traversal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          145
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/145"> Binary Tree Postorder Traversal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          146
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/146"> LRU Cache</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          147
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/147"> Insertion Sort List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          148
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/148"> Sort List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          150
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/150"> Evaluate Reverse Polish Notation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          151
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/151"> Reverse Words in a String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          152
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/152"> Maximum Product Subarray</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          153
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/153"> Find Minimum in Rotated Sorted Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          156
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/156"> Binary Tree Upside Down</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          159
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/159"> Longest Substring with At Most Two Distinct Characters</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          161
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/161"> One Edit Distance</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          162
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/162"> Find Peak Element</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          165
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/165"> Compare Version Numbers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          166
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/166"> Fraction to Recurring Decimal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          173
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/173"> Binary Search Tree Iterator</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          179
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/179"> Largest Number</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          186
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/186"> Reverse Words in a String II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          187
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/187"> Repeated DNA Sequences</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          189
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/189"> Rotate Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          198
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/198"> House Robber</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          199
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/199"> Binary Tree Right Side View</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          200
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/200"> Number of Islands</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          201
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/201"> Bitwise AND of Numbers Range</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          207
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/207"> Course Schedule</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          208
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/208"> Implement Trie (Prefix Tree)</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          209
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/209"> Minimum Size Subarray Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          210
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/210"> Course Schedule II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          211
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/211"> Design Add and Search Words Data Structure</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          213
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/213"> House Robber II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          215
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/215"> Kth Largest Element in an Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          216
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/216"> Combination Sum III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          220
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/220"> Contains Duplicate III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          221
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/221"> Maximal Square</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          222
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/222"> Count Complete Tree Nodes</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          223
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/223"> Rectangle Area</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          227
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/227"> Basic Calculator II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          229
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/229"> Majority Element II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          230
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/230"> Kth Smallest Element in a BST</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          236
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/236"> Lowest Common Ancestor of a Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          238
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/238"> Product of Array Except Self</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          240
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/240"> Search a 2D Matrix II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          241
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/241"> Different Ways to Add Parentheses</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          244
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/244"> Shortest Word Distance II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          245
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/245"> Shortest Word Distance III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          247
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/247"> Strobogrammatic Number II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          249
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/249"> Group Shifted Strings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          250
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/250"> Count Univalue Subtrees</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          251
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/251"> Flatten 2D Vector</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          253
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/253"> Meeting Rooms II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          254
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/254"> Factor Combinations</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          255
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/255"> Verify Preorder Sequence in Binary Search Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          256
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/256"> Paint House</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          259
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/259"> 3Sum Smaller</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          260
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/260"> Single Number III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          261
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/261"> Graph Valid Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          264
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/264"> Ugly Number II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          267
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/267"> Palindrome Permutation II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          271
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/271"> Encode and Decode Strings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          274
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/274"> H-Index</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          275
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/275"> H-Index II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          276
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/276"> Paint Fence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          277
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/277"> Find the Celebrity</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          279
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/279"> Perfect Squares</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          280
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/280"> Wiggle Sort</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          281
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/281"> Zigzag Iterator</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          284
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/284"> Peeking Iterator</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          285
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/285"> Inorder Successor in BST</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          286
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/286"> Walls and Gates</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          287
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/287"> Find the Duplicate Number</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          288
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/288"> Unique Word Abbreviation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          289
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/289"> Game of Life</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          291
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/291"> Word Pattern II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          294
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/294"> Flip Game II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          298
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/298"> Binary Tree Longest Consecutive Sequence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          299
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/299"> Bulls and Cows</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          300
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/300"> Longest Increasing Subsequence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          304
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/304"> Range Sum Query 2D - Immutable</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          306
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/306"> Additive Number</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          307
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/307"> Range Sum Query - Mutable</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          309
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/309"> Best Time to Buy and Sell Stock with Cooldown</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          310
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/310"> Minimum Height Trees</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          311
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/311"> Sparse Matrix Multiplication</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          313
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/313"> Super Ugly Number</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          314
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/314"> Binary Tree Vertical Order Traversal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          316
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/316"> Remove Duplicate Letters</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          318
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/318"> Maximum Product of Word Lengths</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          319
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/319"> Bulb Switcher</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          320
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/320"> Generalized Abbreviation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          322
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/322"> Coin Change</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          323
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/323"> Number of Connected Components in an Undirected Graph</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          324
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/324"> Wiggle Sort II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          325
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/325"> Maximum Size Subarray Sum Equals k</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          328
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/328"> Odd Even Linked List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          331
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/331"> Verify Preorder Serialization of a Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          332
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/332"> Reconstruct Itinerary</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          333
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/333"> Largest BST Subtree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          334
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/334"> Increasing Triplet Subsequence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          337
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/337"> House Robber III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          338
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/338"> Counting Bits</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          339
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/339"> Nested List Weight Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          340
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/340"> Longest Substring with At Most K Distinct Characters</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          341
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/341"> Flatten Nested List Iterator</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          343
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/343"> Integer Break</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          347
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/347"> Top K Frequent Elements</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          348
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/348"> Design Tic-Tac-Toe</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          351
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/351"> Android Unlock Patterns</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          353
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/353"> Design Snake Game</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          355
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/355"> Design Twitter</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          356
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/356"> Line Reflection</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          357
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/357"> Count Numbers with Unique Digits</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          360
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/360"> Sort Transformed Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          361
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/361"> Bomb Enemy</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          362
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/362"> Design Hit Counter</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          364
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/364"> Nested List Weight Sum II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          365
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/365"> Water and Jug Problem</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          366
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/366"> Find Leaves of Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          368
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/368"> Largest Divisible Subset</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          369
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/369"> Plus One Linked List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          370
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/370"> Range Addition</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          371
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/371"> Sum of Two Integers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          372
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/372"> Super Pow</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          373
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/373"> Find K Pairs with Smallest Sums</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          375
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/375"> Guess Number Higher or Lower II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          376
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/376"> Wiggle Subsequence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          377
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/377"> Combination Sum IV</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          378
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/378"> Kth Smallest Element in a Sorted Matrix</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          379
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/379"> Design Phone Directory</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          380
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/380"> Insert Delete GetRandom O(1)</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          382
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/382"> Linked List Random Node</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          384
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/384"> Shuffle an Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          385
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/385"> Mini Parser</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          386
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/386"> Lexicographical Numbers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          388
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/388"> Longest Absolute File Path</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          390
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/390"> Elimination Game</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          393
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/393"> UTF-8 Validation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          394
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/394"> Decode String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          395
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/395"> Longest Substring with At Least K Repeating Characters</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          396
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/396"> Rotate Function</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          397
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/397"> Integer Replacement</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          398
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/398"> Random Pick Index</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          399
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/399"> Evaluate Division</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          400
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/400"> Nth Digit</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          402
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/402"> Remove K Digits</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          406
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/406"> Queue Reconstruction by Height</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          413
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/413"> Arithmetic Slices</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          416
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/416"> Partition Equal Subset Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          417
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/417"> Pacific Atlantic Water Flow</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          418
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/418"> Sentence Screen Fitting</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          419
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/419"> Battleships in a Board</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          421
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/421"> Maximum XOR of Two Numbers in an Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          423
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/423"> Reconstruct Original Digits from English</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          424
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/424"> Longest Repeating Character Replacement</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          426
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/426"> Convert Binary Search Tree to Sorted Doubly Linked List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          427
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/427"> Construct Quad Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          429
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/429"> N-ary Tree Level Order Traversal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          430
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/430"> Flatten a Multilevel Doubly Linked List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          433
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/433"> Minimum Genetic Mutation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          435
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/435"> Non-overlapping Intervals</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          436
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/436"> Find Right Interval</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          437
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/437"> Path Sum III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          438
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/438"> Find All Anagrams in a String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          439
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/439"> Ternary Expression Parser</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          442
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/442"> Find All Duplicates in an Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          443
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/443"> String Compression</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          444
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/444"> Sequence Reconstruction</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          445
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/445"> Add Two Numbers II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          447
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/447"> Number of Boomerangs</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          449
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/449"> Serialize and Deserialize BST</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          450
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/450"> Delete Node in a BST</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          451
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/451"> Sort Characters By Frequency</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          452
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/452"> Minimum Number of Arrows to Burst Balloons</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          454
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/454"> 4Sum II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          456
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/456"> 132 Pattern</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          457
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/457"> Circular Array Loop</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          462
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/462"> Minimum Moves to Equal Array Elements II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          464
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/464"> Can I Win</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          467
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/467"> Unique Substrings in Wraparound String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          468
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/468"> Validate IP Address</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          469
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/469"> Convex Polygon</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          470
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/470"> Implement Rand10() Using Rand7()</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          473
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/473"> Matchsticks to Square</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          474
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/474"> Ones and Zeroes</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          475
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/475"> Heaters</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          477
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/477"> Total Hamming Distance</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          478
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/478"> Generate Random Point in a Circle</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          481
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/481"> Magical String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          484
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/484"> Find Permutation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          486
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/486"> Predict the Winner</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          487
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/487"> Max Consecutive Ones II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          490
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/490"> The Maze</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          491
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/491"> Increasing Subsequences</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          494
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/494"> Target Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          495
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/495"> Teemo Attacking</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          497
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/497"> Random Point in Non-overlapping Rectangles</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          498
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/498"> Diagonal Traverse</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          503
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/503"> Next Greater Element II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          505
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/505"> The Maze II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          508
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/508"> Most Frequent Subtree Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          510
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/510"> Inorder Successor in BST II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          513
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/513"> Find Bottom Left Tree Value</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          515
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/515"> Find Largest Value in Each Tree Row</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          516
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/516"> Longest Palindromic Subsequence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          518
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/518"> Coin Change 2</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          519
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/519"> Random Flip Matrix</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          522
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/522"> Longest Uncommon Subsequence II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          523
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/523"> Continuous Subarray Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          524
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/524"> Longest Word in Dictionary through Deleting</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          525
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/525"> Contiguous Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          526
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/526"> Beautiful Arrangement</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          528
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/528"> Random Pick with Weight</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          529
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/529"> Minesweeper</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          531
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/531"> Lonely Pixel I</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          532
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/532"> K-diff Pairs in an Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          533
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/533"> Lonely Pixel II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          535
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/535"> Encode and Decode TinyURL</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          536
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/536"> Construct Binary Tree from String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          537
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/537"> Complex Number Multiplication</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          538
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/538"> Convert BST to Greater Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          539
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/539"> Minimum Time Difference</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          540
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/540"> Single Element in a Sorted Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          542
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/542"> 01 Matrix</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          544
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/544"> Output Contest Matches</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          545
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/545"> Boundary of Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          547
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/547"> Number of Provinces</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          548
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/548"> Split Array with Equal Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          549
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/549"> Binary Tree Longest Consecutive Sequence II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          553
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/553"> Optimal Division</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          554
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/554"> Brick Wall</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          555
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/555"> Split Concatenated Strings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          556
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/556"> Next Greater Element III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          558
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/558"> Logical OR of Two Binary Grids Represented as Quad-Trees</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          560
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/560"> Subarray Sum Equals K</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          562
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/562"> Longest Line of Consecutive One in Matrix</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          565
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/565"> Array Nesting</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          567
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/567"> Permutation in String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          573
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/573"> Squirrel Simulation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          576
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/576"> Out of Boundary Paths</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          581
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/581"> Shortest Unsorted Continuous Subarray</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          582
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/582"> Kill Process</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          583
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/583"> Delete Operation for Two Strings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          592
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/592"> Fraction Addition and Subtraction</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          593
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/593"> Valid Square</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          609
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/609"> Find Duplicate File in System</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          611
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/611"> Valid Triangle Number</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          616
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/616"> Add Bold Tag in String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          621
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/621"> Task Scheduler</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          622
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/622"> Design Circular Queue</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          623
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/623"> Add One Row to Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          624
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/624"> Maximum Distance in Arrays</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          625
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/625"> Minimum Factorization</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          633
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/633"> Sum of Square Numbers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          634
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/634"> Find the Derangement of An Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          635
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/635"> Design Log Storage System</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          636
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/636"> Exclusive Time of Functions</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          638
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/638"> Shopping Offers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          640
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/640"> Solve the Equation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          641
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/641"> Design Circular Deque</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          646
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/646"> Maximum Length of Pair Chain</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          647
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/647"> Palindromic Substrings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          648
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/648"> Replace Words</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          649
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/649"> Dota2 Senate</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          650
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/650"> 2 Keys Keyboard</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          651
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/651"> 4 Keys Keyboard</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          652
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/652"> Find Duplicate Subtrees</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          654
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/654"> Maximum Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          655
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/655"> Print Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          658
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/658"> Find K Closest Elements</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          659
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/659"> Split Array into Consecutive Subsequences</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          662
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/662"> Maximum Width of Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          663
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/663"> Equal Tree Partition</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          665
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/665"> Non-decreasing Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          666
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/666"> Path Sum IV</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          667
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/667"> Beautiful Arrangement II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          669
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/669"> Trim a Binary Search Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          670
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/670"> Maximum Swap</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          672
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/672"> Bulb Switcher II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          673
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/673"> Number of Longest Increasing Subsequence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          676
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/676"> Implement Magic Dictionary</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          677
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/677"> Map Sum Pairs</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          678
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/678"> Valid Parenthesis String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          681
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/681"> Next Closest Time</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          684
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/684"> Redundant Connection</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          686
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/686"> Repeated String Match</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          687
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/687"> Longest Univalue Path</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          688
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/688"> Knight Probability in Chessboard</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          692
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/692"> Top K Frequent Words</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          694
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/694"> Number of Distinct Islands</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          695
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/695"> Max Area of Island</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          698
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/698"> Partition to K Equal Sum Subsets</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          701
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/701"> Insert into a Binary Search Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          702
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/702"> Search in a Sorted Array of Unknown Size</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          707
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/707"> Design Linked List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          708
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/708"> Insert into a Sorted Circular Linked List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          712
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/712"> Minimum ASCII Delete Sum for Two Strings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          713
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/713"> Subarray Product Less Than K</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          714
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/714"> Best Time to Buy and Sell Stock with Transaction Fee</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          718
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/718"> Maximum Length of Repeated Subarray</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          721
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/721"> Accounts Merge</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          722
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/722"> Remove Comments</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          723
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/723"> Candy Crush</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          725
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/725"> Split Linked List in Parts</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          729
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/729"> My Calendar I</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          731
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/731"> My Calendar II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          735
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/735"> Asteroid Collision</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          737
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/737"> Sentence Similarity II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          738
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/738"> Monotone Increasing Digits</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          739
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/739"> Daily Temperatures</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          740
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/740"> Delete and Earn</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          742
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/742"> Closest Leaf in a Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          743
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/743"> Network Delay Time</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          750
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/750"> Number Of Corner Rectangles</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          751
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/751"> IP to CIDR</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          752
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/752"> Open the Lock</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          754
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/754"> Reach a Number</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          755
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/755"> Pour Water</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          756
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/756"> Pyramid Transition Matrix</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          763
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/763"> Partition Labels</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          764
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/764"> Largest Plus Sign</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          767
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/767"> Reorganize String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          769
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/769"> Max Chunks To Make Sorted</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          775
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/775"> Global and Local Inversions</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          776
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/776"> Split BST</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          777
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/777"> Swap Adjacent in LR String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          779
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/779"> K-th Symbol in Grammar</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          781
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/781"> Rabbits in Forest</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          784
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/784"> Letter Case Permutation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          785
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/785"> Is Graph Bipartite?</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          787
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/787"> Cheapest Flights Within K Stops</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          789
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/789"> Escape The Ghosts</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          790
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/790"> Domino and Tromino Tiling</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          791
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/791"> Custom Sort String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          792
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/792"> Number of Matching Subsequences</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          794
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/794"> Valid Tic-Tac-Toe State</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          795
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/795"> Number of Subarrays with Bounded Maximum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          797
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/797"> All Paths From Source to Target</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          799
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/799"> Champagne Tower</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          801
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/801"> Minimum Swaps To Make Sequences Increasing</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          802
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/802"> Find Eventual Safe States</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          807
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/807"> Max Increase to Keep City Skyline</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          808
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/808"> Soup Servings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          809
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/809"> Expressive Words</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          813
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/813"> Largest Sum of Averages</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          814
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/814"> Binary Tree Pruning</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          816
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/816"> Ambiguous Coordinates</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          817
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/817"> Linked List Components</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          820
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/820"> Short Encoding of Words</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          822
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/822"> Card Flipping Game</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          823
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/823"> Binary Trees With Factors</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          825
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/825"> Friends Of Appropriate Ages</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          826
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/826"> Most Profit Assigning Work</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          831
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/831"> Masking Personal Information</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          833
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/833"> Find And Replace in String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          835
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/835"> Image Overlap</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          837
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/837"> New 21 Game</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          838
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/838"> Push Dominoes</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          840
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/840"> Magic Squares In Grid</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          841
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/841"> Keys and Rooms</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          842
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/842"> Split Array into Fibonacci Sequence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          845
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/845"> Longest Mountain in Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          846
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/846"> Hand of Straights</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          848
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/848"> Shifting Letters</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          849
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/849"> Maximize Distance to Closest Person</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          851
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/851"> Loud and Rich</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          853
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/853"> Car Fleet</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          855
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/855"> Exam Room</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          856
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/856"> Score of Parentheses</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          858
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/858"> Mirror Reflection</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          861
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/861"> Score After Flipping Matrix</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          863
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/863"> All Nodes Distance K in Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          865
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/865"> Smallest Subtree with all the Deepest Nodes</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          866
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/866"> Prime Palindrome</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          869
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/869"> Reordered Power of 2</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          870
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/870"> Advantage Shuffle</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          873
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/873"> Length of Longest Fibonacci Subsequence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          875
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/875"> Koko Eating Bananas</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          877
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/877"> Stone Game</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          880
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/880"> Decoded String at Index</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          881
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/881"> Boats to Save People</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          885
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/885"> Spiral Matrix III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          886
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/886"> Possible Bipartition</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          889
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/889"> Construct Binary Tree from Preorder and Postorder Traversal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          890
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/890"> Find and Replace Pattern</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          894
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/894"> All Possible Full Binary Trees</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          898
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/898"> Bitwise ORs of Subarrays</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          900
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/900"> RLE Iterator</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          901
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/901"> Online Stock Span</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          904
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/904"> Fruit Into Baskets</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          907
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/907"> Sum of Subarray Minimums</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          909
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/909"> Snakes and Ladders</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          910
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/910"> Smallest Range II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          911
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/911"> Online Election</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          912
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/912"> Sort an Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          915
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/915"> Partition Array into Disjoint Intervals</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          916
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/916"> Word Subsets</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          918
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/918"> Maximum Sum Circular Subarray</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          919
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/919"> Complete Binary Tree Inserter</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          921
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/921"> Minimum Add to Make Parentheses Valid</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          923
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/923"> 3Sum With Multiplicity</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          926
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/926"> Flip String to Monotone Increasing</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          930
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/930"> Binary Subarrays With Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          931
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/931"> Minimum Falling Path Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          932
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/932"> Beautiful Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          934
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/934"> Shortest Bridge</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          935
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/935"> Knight Dialer</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          939
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/939"> Minimum Area Rectangle</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          945
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/945"> Minimum Increment to Make Array Unique</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          946
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/946"> Validate Stack Sequences</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          947
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/947"> Most Stones Removed with Same Row or Column</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          948
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/948"> Bag of Tokens</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          949
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/949"> Largest Time for Given Digits</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          950
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/950"> Reveal Cards In Increasing Order</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          951
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/951"> Flip Equivalent Binary Trees</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          954
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/954"> Array of Doubled Pairs</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          955
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/955"> Delete Columns to Make Sorted II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          957
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/957"> Prison Cells After N Days</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          958
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/958"> Check Completeness of a Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          959
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/959"> Regions Cut By Slashes</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          962
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/962"> Maximum Width Ramp</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          963
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/963"> Minimum Area Rectangle II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          966
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/966"> Vowel Spellchecker</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          967
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/967"> Numbers With Same Consecutive Differences</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          969
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/969"> Pancake Sorting</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          970
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/970"> Powerful Integers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          971
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/971"> Flip Binary Tree To Match Preorder Traversal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          973
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/973"> K Closest Points to Origin</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          974
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/974"> Subarray Sums Divisible by K</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          978
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/978"> Longest Turbulent Subarray</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          979
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/979"> Distribute Coins in Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          981
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/981"> Time Based Key-Value Store</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          983
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/983"> Minimum Cost For Tickets</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          984
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/984"> String Without AAA or BBB</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          986
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/986"> Interval List Intersections</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          988
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/988"> Smallest String Starting From Leaf</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          990
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/990"> Satisfiability of Equality Equations</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          991
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/991"> Broken Calculator</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          994
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/994"> Rotting Oranges</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          998
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/998"> Maximum Binary Tree II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1003
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1003"> Check If Word Is Valid After Substitutions</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1004
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1004"> Max Consecutive Ones III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1006
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1006"> Clumsy Factorial</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1007
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1007"> Minimum Domino Rotations For Equal Row</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1008
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1008"> Construct Binary Search Tree from Preorder Traversal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1010
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1010"> Pairs of Songs With Total Durations Divisible by 60</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1011
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1011"> Capacity To Ship Packages Within D Days</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1014
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1014"> Best Sightseeing Pair</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1015
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1015"> Smallest Integer Divisible by K</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1016
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1016"> Binary String With Substrings Representing 1 To N</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1017
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1017"> Convert to Base -2</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1019
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1019"> Next Greater Node In Linked List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1020
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1020"> Number of Enclaves</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1023
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1023"> Camelcase Matching</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1024
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1024"> Video Stitching</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1026
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1026"> Maximum Difference Between Node and Ancestor</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1027
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1027"> Longest Arithmetic Subsequence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1029
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1029"> Two City Scheduling</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1031
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1031"> Maximum Sum of Two Non-Overlapping Subarrays</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1034
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1034"> Coloring A Border</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1035
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1035"> Uncrossed Lines</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1038
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1038"> Binary Search Tree to Greater Sum Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1039
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1039"> Minimum Score Triangulation of Polygon</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1040
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1040"> Moving Stones Until Consecutive II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1041
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1041"> Robot Bounded In Circle</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1042
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1042"> Flower Planting With No Adjacent</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1043
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1043"> Partition Array for Maximum Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1048
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1048"> Longest String Chain</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1049
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1049"> Last Stone Weight II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1052
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1052"> Grumpy Bookstore Owner</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1053
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1053"> Previous Permutation With One Swap</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1054
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1054"> Distant Barcodes</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1055
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1055"> Shortest Way to Form String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1057
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1057"> Campus Bikes</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1058
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1058"> Minimize Rounding Error to Meet Target</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1059
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1059"> All Paths from Source Lead to Destination</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1060
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1060"> Missing Element in Sorted Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1061
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1061"> Lexicographically Smallest Equivalent String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1062
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1062"> Longest Repeating Substring</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1066
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1066"> Campus Bikes II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1072
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1072"> Flip Columns For Maximum Number of Equal Rows</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1073
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1073"> Adding Two Negabinary Numbers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1079
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1079"> Letter Tile Possibilities</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1080
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1080"> Insufficient Nodes in Root to Leaf Paths</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1081
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1081"> Smallest Subsequence of Distinct Characters</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1087
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1087"> Brace Expansion</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1090
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1090"> Largest Values From Labels</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1091
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1091"> Shortest Path in Binary Matrix</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1093
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1093"> Statistics from a Large Sample</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1094
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1094"> Car Pooling</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1100
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1100"> Find K-Length Substrings With No Repeated Characters</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1101
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1101"> The Earliest Moment When Everyone Become Friends</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1102
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1102"> Path With Maximum Minimum Value</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1104
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1104"> Path In Zigzag Labelled Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1105
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1105"> Filling Bookcase Shelves</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1109
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1109"> Corporate Flight Bookings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1110
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1110"> Delete Nodes And Return Forest</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1111
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1111"> Maximum Nesting Depth of Two Valid Parentheses Strings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1120
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1120"> Maximum Average Subtree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1123
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1123"> Lowest Common Ancestor of Deepest Leaves</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1124
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1124"> Longest Well-Performing Interval</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1129
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1129"> Shortest Path with Alternating Colors</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1130
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1130"> Minimum Cost Tree From Leaf Values</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1131
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1131"> Maximum of Absolute Value Expression</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1135
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1135"> Connecting Cities With Minimum Cost</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1136
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1136"> Parallel Courses</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1138
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1138"> Alphabet Board Path</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1139
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1139"> Largest 1-Bordered Square</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1140
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1140"> Stone Game II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1143
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1143"> Longest Common Subsequence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1144
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1144"> Decrease Elements To Make Array Zigzag</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1145
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1145"> Binary Tree Coloring Game</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1146
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1146"> Snapshot Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1151
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1151"> Minimum Swaps to Group All 1&#x27;s Together</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1152
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1152"> Analyze User Website Visit Pattern</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1155
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1155"> Number of Dice Rolls With Target Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1156
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1156"> Swap For Longest Repeated Character Substring</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1161
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1161"> Maximum Level Sum of a Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1162
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1162"> As Far from Land as Possible</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1166
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1166"> Design File System</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1167
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1167"> Minimum Cost to Connect Sticks</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1169
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1169"> Invalid Transactions</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1170
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1170"> Compare Strings by Frequency of the Smallest Character</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1171
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1171"> Remove Zero Sum Consecutive Nodes from Linked List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1177
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1177"> Can Make Palindrome from Substring</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1181
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1181"> Before and After Puzzle</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1182
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1182"> Shortest Distance to Target Color</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1186
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1186"> Maximum Subarray Sum with One Deletion</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1190
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1190"> Reverse Substrings Between Each Pair of Parentheses</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1191
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1191"> K-Concatenation Maximum Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1197
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1197"> Minimum Knight Moves</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1198
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1198"> Find Smallest Common Element in All Rows</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1201
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1201"> Ugly Number III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1202
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1202"> Smallest String With Swaps</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1208
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1208"> Get Equal Substrings Within Budget</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1209
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1209"> Remove All Adjacent Duplicates in String II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1214
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1214"> Two Sum BSTs</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1215
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1215"> Stepping Numbers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1218
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1218"> Longest Arithmetic Subsequence of Given Difference</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1219
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1219"> Path with Maximum Gold</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1222
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1222"> Queens That Can Attack the King</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1227
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1227"> Airplane Seat Assignment Probability</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1229
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1229"> Meeting Scheduler</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1230
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1230"> Toss Strange Coins</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1233
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1233"> Remove Sub-Folders from the Filesystem</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1234
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1234"> Replace the Substring for Balanced String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1236
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1236"> Web Crawler</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1237
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1237"> Find Positive Integer Solution for a Given Equation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1238
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1238"> Circular Permutation in Binary Representation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1239
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1239"> Maximum Length of a Concatenated String with Unique Characters</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1244
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1244"> Design A Leaderboard</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1245
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1245"> Tree Diameter</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1247
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1247"> Minimum Swaps to Make Strings Equal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1248
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1248"> Count Number of Nice Subarrays</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1249
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1249"> Minimum Remove to Make Valid Parentheses</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1253
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1253"> Reconstruct a 2-Row Binary Matrix</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1254
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1254"> Number of Closed Islands</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1256
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1256"> Encode Number</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1257
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1257"> Smallest Common Region</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1258
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1258"> Synonymous Sentences</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1261
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1261"> Find Elements in a Contaminated Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1262
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1262"> Greatest Sum Divisible by Three</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1265
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1265"> Print Immutable Linked List in Reverse</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1267
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1267"> Count Servers that Communicate</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1268
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1268"> Search Suggestions System</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1272
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1272"> Remove Interval</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1273
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1273"> Delete Tree Nodes</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1276
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1276"> Number of Burgers with No Waste of Ingredients</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1277
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1277"> Count Square Submatrices with All Ones</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1282
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1282"> Group the People Given the Group Size They Belong To</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1283
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1283"> Find the Smallest Divisor Given a Threshold</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1286
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1286"> Iterator for Combination</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1288
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1288"> Remove Covered Intervals</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1291
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1291"> Sequential Digits</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1292
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1292"> Maximum Side Length of a Square with Sum Less than or Equal to Threshold</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1296
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1296"> Divide Array in Sets of K Consecutive Numbers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1297
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1297"> Maximum Number of Occurrences of a Substring</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1300
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1300"> Sum of Mutated Array Closest to Target</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1302
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1302"> Deepest Leaves Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1305
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1305"> All Elements in Two Binary Search Trees</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1306
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1306"> Jump Game III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1310
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1310"> XOR Queries of a Subarray</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1311
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1311"> Get Watched Videos by Your Friends</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1314
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1314"> Matrix Block Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1315
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1315"> Sum of Nodes with Even-Valued Grandparent</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1318
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1318"> Minimum Flips to Make a OR b Equal to c</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1319
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1319"> Number of Operations to Make Network Connected</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1324
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1324"> Print Words Vertically</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1325
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1325"> Delete Leaves With a Given Value</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1328
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1328"> Break a Palindrome</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1329
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1329"> Sort the Matrix Diagonally</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1333
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1333"> Filter Restaurants by Vegan-Friendly, Price and Distance</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1334
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1334"> Find the City With the Smallest Number of Neighbors at a Threshold Distance</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1338
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1338"> Reduce Array Size to The Half</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1339
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1339"> Maximum Product of Splitted Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1343
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1343"> Number of Sub-arrays of Size K and Average Greater than or Equal to Threshold</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1344
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1344"> Angle Between Hands of a Clock</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1347
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1347"> Minimum Number of Steps to Make Two Strings Anagram</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1348
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1348"> Tweet Counts Per Frequency</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1352
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1352"> Product of the Last K Numbers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1353
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1353"> Maximum Number of Events That Can Be Attended</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1357
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1357"> Apply Discount Every n Orders</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1358
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1358"> Number of Substrings Containing All Three Characters</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1361
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1361"> Validate Binary Tree Nodes</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1362
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1362"> Closest Divisors</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1366
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1366"> Rank Teams by Votes</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1367
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1367"> Linked List in Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1371
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1371"> Find the Longest Substring Containing Vowels in Even Counts</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1372
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1372"> Longest ZigZag Path in a Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1375
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1375"> Bulb Switcher III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1376
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1376"> Time Needed to Inform All Employees</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1379
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1379"> Find a Corresponding Node of a Binary Tree in a Clone of That Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1381
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1381"> Design a Stack With Increment Operation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1382
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1382"> Balance a Binary Search Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1386
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1386"> Cinema Seat Allocation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1387
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1387"> Sort Integers by The Power Value</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1390
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1390"> Four Divisors</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1391
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1391"> Check if There is a Valid Path in a Grid</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1395
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1395"> Count Number of Teams</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1396
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1396"> Design Underground System</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1400
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1400"> Construct K Palindrome Strings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1401
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1401"> Circle and Rectangle Overlapping</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1404
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1404"> Number of Steps to Reduce a Number in Binary Representation to One</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1405
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1405"> Longest Happy String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1409
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1409"> Queries on a Permutation With Key</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1410
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1410"> HTML Entity Parser</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1414
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1414"> Find the Minimum Number of Fibonacci Numbers Whose Sum Is K</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1415
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1415"> The k-th Lexicographical String of All Happy Strings of Length n</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1418
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1418"> Display Table of Food Orders in a Restaurant</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1419
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1419"> Minimum Number of Frogs Croaking</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1423
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1423"> Maximum Points You Can Obtain from Cards</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1424
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1424"> Diagonal Traverse II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1428
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1428"> Leftmost Column with at Least a One</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1429
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1429"> First Unique Number</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1430
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1430"> Check If a String Is a Valid Sequence from Root to Leaves Path in a Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1432
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1432"> Max Difference You Can Get From Changing an Integer</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1433
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1433"> Check If a String Can Break Another String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1438
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1438"> Longest Continuous Subarray With Absolute Diff Less Than or Equal to Limit</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1442
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1442"> Count Triplets That Can Form Two Arrays of Equal XOR</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1443
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1443"> Minimum Time to Collect All Apples in a Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1447
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1447"> Simplified Fractions</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1448
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1448"> Count Good Nodes in Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1451
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1451"> Rearrange Words in a Sentence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1452
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1452"> People Whose List of Favorite Companies Is Not a Subset of Another List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1456
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1456"> Maximum Number of Vowels in a Substring of Given Length</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1457
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1457"> Pseudo-Palindromic Paths in a Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1461
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1461"> Check If a String Contains All Binary Codes of Size K</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1462
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1462"> Course Schedule IV</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1465
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1465"> Maximum Area of a Piece of Cake After Horizontal and Vertical Cuts</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1466
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1466"> Reorder Routes to Make All Paths Lead to the City Zero</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1471
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1471"> The k Strongest Values in an Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1472
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1472"> Design Browser History</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1476
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1476"> Subrectangle Queries</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1477
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1477"> Find Two Non-overlapping Sub-arrays Each With Target Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1481
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1481"> Least Number of Unique Integers after K Removals</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1482
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1482"> Minimum Number of Days to Make m Bouquets</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1485
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1485"> Clone Binary Tree With Random Pointer</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1487
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1487"> Making File Names Unique</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1488
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1488"> Avoid Flood in The City</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1490
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1490"> Clone N-ary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1492
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1492"> The kth Factor of n</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1493
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1493"> Longest Subarray of 1&#x27;s After Deleting One Element</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1497
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1497"> Check If Array Pairs Are Divisible by k</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1498
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1498"> Number of Subsequences That Satisfy the Given Sum Condition</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1500
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1500"> Design a File Sharing System</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1503
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1503"> Last Moment Before All Ants Fall Out of a Plank</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1504
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1504"> Count Submatrices With All Ones</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1506
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1506"> Find Root of N-Ary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1508
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1508"> Range Sum of Sorted Subarray Sums</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1509
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1509"> Minimum Difference Between Largest and Smallest Value in Three Moves</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1513
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1513"> Number of Substrings With Only 1s</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1514
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1514"> Path with Maximum Probability</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1519
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1519"> Number of Nodes in the Sub-Tree With the Same Label</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1522
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1522"> Diameter of N-Ary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1524
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1524"> Number of Sub-arrays With Odd Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1525
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1525"> Number of Good Ways to Split a String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1529
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1529"> Bulb Switcher IV</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1530
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1530"> Number of Good Leaf Nodes Pairs</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1533
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1533"> Find the Index of the Large Integer</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1535
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1535"> Find the Winner of an Array Game</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1536
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1536"> Minimum Swaps to Arrange a Binary Grid</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1538
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1538"> Guess the Majority in a Hidden Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1540
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1540"> Can Convert String in K Moves</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1541
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1541"> Minimum Insertions to Balance a Parentheses String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1545
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1545"> Find Kth Bit in Nth Binary String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1546
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1546"> Maximum Number of Non-Overlapping Subarrays With Sum Equals Target</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1551
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1551"> Minimum Operations to Make Array Equal</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1552
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1552"> Magnetic Force Between Two Balls</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1554
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1554"> Strings Differ by One Character</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1557
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1557"> Minimum Number of Vertices to Reach All Nodes</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1558
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1558"> Minimum Numbers of Function Calls to Make Target Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1561
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1561"> Maximum Number of Coins You Can Get</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1562
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1562"> Find Latest Group of Size M</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1564
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1564"> Put Boxes Into the Warehouse I</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1567
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1567"> Maximum Length of Subarray With Positive Product</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1570
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1570"> Dot Product of Two Sparse Vectors</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1573
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1573"> Number of Ways to Split a String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1574
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1574"> Shortest Subarray to be Removed to Make Array Sorted</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1577
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1577"> Number of Ways Where Square of Number Is Equal to Product of Two Numbers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1578
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1578"> Minimum Deletion Cost to Avoid Repeating Letters</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1580
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1580"> Put Boxes Into the Warehouse II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1583
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1583"> Count Unhappy Friends</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1584
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1584"> Min Cost to Connect All Points</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1586
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1586"> Binary Search Tree Iterator II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1589
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1589"> Maximum Sum Obtained of Any Permutation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1590
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1590"> Make Sum Divisible by P</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1593
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1593"> Split a String Into the Max Number of Unique Substrings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1594
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1594"> Maximum Non Negative Product in a Matrix</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1599
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1599"> Maximum Profit of Operating a Centennial Wheel</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1600
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1600"> Throne Inheritance</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1602
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1602"> Find Nearest Right Node in Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1604
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1604"> Alert Using Same Key-Card Three or More Times in a One Hour Period</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1605
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1605"> Find Valid Matrix Given Row and Column Sums</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1609
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1609"> Even Odd Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1612
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1612"> Check If Two Expression Trees are Equivalent</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1615
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1615"> Maximal Network Rank</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1616
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1616"> Split Two Strings to Make Palindrome</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1618
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1618"> Maximum Font to Fit a Sentence in a Screen</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1620
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1620"> Coordinate With Maximum Network Quality</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1621
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1621"> Number of Sets of K Non-Overlapping Line Segments</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1625
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1625"> Lexicographically Smallest String After Applying Operations</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1626
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1626"> Best Team With No Conflicts</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1628
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1628"> Design an Expression Tree With Evaluate Function</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1630
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1630"> Arithmetic Subarrays</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1631
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1631"> Path With Minimum Effort</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1634
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1634"> Add Two Polynomials Represented as Linked Lists</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1637
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1637"> Widest Vertical Area Between Two Points Containing No Points</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1638
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1638"> Count Substrings That Differ by One Character</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1641
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1641"> Count Sorted Vowel Strings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1642
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1642"> Furthest Building You Can Reach</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1644
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1644"> Lowest Common Ancestor of a Binary Tree II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1647
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1647"> Minimum Deletions to Make Character Frequencies Unique</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1648
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1648"> Sell Diminishing-Valued Colored Balls</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1650
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1650"> Lowest Common Ancestor of a Binary Tree III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1653
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1653"> Minimum Deletions to Make String Balanced</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1654
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1654"> Minimum Jumps to Reach Home</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1657
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1657"> Determine if Two Strings Are Close</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1658
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1658"> Minimum Operations to Reduce X to Zero</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1660
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1660"> Correct a Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1663
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1663"> Smallest String With A Given Numeric Value</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1664
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1664"> Ways to Make a Fair Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1666
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1666"> Change the Root of a Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1669
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1669"> Merge In Between Linked Lists</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1670
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1670"> Design Front Middle Back Queue</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1673
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1673"> Find the Most Competitive Subsequence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1674
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1674"> Minimum Moves to Make Array Complementary</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1676
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1676"> Lowest Common Ancestor of a Binary Tree IV</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1679
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1679"> Max Number of K-Sum Pairs</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1680
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1680"> Concatenation of Consecutive Binary Numbers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1682
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1682"> Longest Palindromic Subsequence II</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1685
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1685"> Sum of Absolute Differences in a Sorted Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1686
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1686"> Stone Game VI</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1689
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1689"> Partitioning Into Minimum Number Of Deci-Binary Numbers</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1690
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1690"> Stone Game VII</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1695
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1695"> Maximum Erasure Value</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1696
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1696"> Jump Game VI</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1698
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1698"> Number of Distinct Substrings in a String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1701
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1701"> Average Waiting Time</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1702
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1702"> Maximum Binary String After Change</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1705
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1705"> Maximum Number of Eaten Apples</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1706
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1706"> Where Will the Ball Fall</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1711
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1711"> Count Good Meals</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1712
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1712"> Ways to Split Array Into Three Subarrays</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1717
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1717"> Maximum Score From Removing Substrings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1718
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1718"> Construct the Lexicographically Largest Valid Sequence</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1721
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1721"> Swapping Nodes in a Linked List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1722
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1722"> Minimize Hamming Distance After Swap Operations</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1726
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1726"> Tuple with Same Product</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1727
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1727"> Largest Submatrix With Rearrangements</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1730
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1730"> Shortest Path to Get Food</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1733
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1733"> Minimum Number of People to Teach</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1734
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1734"> Decode XORed Permutation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1737
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1737"> Change Minimum Characters to Satisfy One of Three Conditions</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1738
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1738"> Find Kth Largest XOR Coordinate Value</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1740
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1740"> Find Distance in a Binary Tree</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1743
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1743"> Restore the Array From Adjacent Pairs</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1744
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1744"> Can You Eat Your Favorite Candy on Your Favorite Day?</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1746
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1746"> Maximum Subarray Sum After One Operation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1749
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1749"> Maximum Absolute Sum of Any Subarray</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1750
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1750"> Minimum Length of String After Deleting Similar Ends</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1753
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1753"> Maximum Score From Removing Stones</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1754
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1754"> Largest Merge Of Two Strings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1756
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1756"> Design Most Recently Used Queue</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1759
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1759"> Count Number of Homogenous Substrings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1760
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1760"> Minimum Limit of Balls in a Bag</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1762
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1762"> Buildings With an Ocean View</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1764
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1764"> Form Array by Concatenating Subarrays of Another Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1765
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1765"> Map of Highest Peak</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1769
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1769"> Minimum Number of Operations to Move All Balls to Each Box</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1770
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1770"> Maximum Score from Performing Multiplication Operations</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1772
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1772"> Sort Features by Popularity</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1774
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1774"> Closest Dessert Cost</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1775
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1775"> Equal Sum Arrays With Minimum Number of Operations</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1778
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1778"> Shortest Path in a Hidden Grid</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1780
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1780"> Check if Number is a Sum of Powers of Three</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1781
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1781"> Sum of Beauty of All Substrings</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1785
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1785"> Minimum Elements to Add to Form a Given Sum</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1786
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1786"> Number of Restricted Paths From First to Last Node</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1791
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1791"> Find Center of Star Graph</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1792
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1792"> Maximum Average Pass Ratio</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1794
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1794"> Count Pairs of Equal Substrings With Minimum Difference</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1797
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1797"> Design Authentication Manager</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1798
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1798"> Maximum Number of Consecutive Values You Can Make</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1801
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1801"> Number of Orders in the Backlog</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1802
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1802"> Maximum Value at a Given Index in a Bounded Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1804
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1804"> Implement Trie II (Prefix Tree)</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1806
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1806"> Minimum Number of Operations to Reinitialize a Permutation</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1807
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1807"> Evaluate the Bracket Pairs of a String</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1810
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1810"> Minimum Path Cost in a Hidden Grid</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1813
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1813"> Sentence Similarity III</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1814
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1814"> Count Nice Pairs in an Array</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1817
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1817"> Finding the Users Active Minutes</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1818
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1818"> Minimum Absolute Sum Difference</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1820
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1820"> Maximum Number of Accepted Invitations</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1823
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1823"> Find the Winner of the Circular Game</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1824
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1824"> Minimum Sideway Jumps</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1828
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1828"> Queries on Number of Points Inside a Circle</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1829
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1829"> Maximum XOR for Each Query</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1833
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1833"> Maximum Ice Cream Bars</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1834
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1834"> Single-Threaded CPU</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          1836
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1836"> Remove Duplicates From an Unsorted Linked List</a>
        </td>
        <td>Medium</td>
      </tr>
      <tr>
        <td>
          4
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/4"> Median of Two Sorted Arrays</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          10
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/10"> Regular Expression Matching</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          23
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/23"> Merge k Sorted Lists</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          25
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/25"> Reverse Nodes in k-Group</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          30
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/30"> Substring with Concatenation of All Words</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          32
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/32"> Longest Valid Parentheses</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          37
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/37"> Sudoku Solver</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          41
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/41"> First Missing Positive</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          42
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/42"> Trapping Rain Water</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          44
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/44"> Wildcard Matching</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          51
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/51"> N-Queens</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          52
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/52"> N-Queens II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          60
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/60"> Permutation Sequence</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          65
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/65"> Valid Number</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          68
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/68"> Text Justification</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          72
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/72"> Edit Distance</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          76
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/76"> Minimum Window Substring</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          84
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/84"> Largest Rectangle in Histogram</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          85
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/85"> Maximal Rectangle</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          87
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/87"> Scramble String</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          99
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/99"> Recover Binary Search Tree</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          115
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/115"> Distinct Subsequences</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          123
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/123"> Best Time to Buy and Sell Stock III</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          124
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/124"> Binary Tree Maximum Path Sum</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          126
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/126"> Word Ladder II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          127
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/127"> Word Ladder</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          128
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/128"> Longest Consecutive Sequence</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          132
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/132"> Palindrome Partitioning II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          135
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/135"> Candy</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          140
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/140"> Word Break II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          149
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/149"> Max Points on a Line</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          154
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/154"> Find Minimum in Rotated Sorted Array II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          158
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/158"> Read N Characters Given Read4 II - Call multiple times</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          164
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/164"> Maximum Gap</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          174
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/174"> Dungeon Game</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          188
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/188"> Best Time to Buy and Sell Stock IV</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          212
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/212"> Word Search II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          214
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/214"> Shortest Palindrome</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          218
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/218"> The Skyline Problem</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          224
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/224"> Basic Calculator</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          233
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/233"> Number of Digit One</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          239
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/239"> Sliding Window Maximum</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          248
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/248"> Strobogrammatic Number III</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          265
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/265"> Paint House II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          269
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/269"> Alien Dictionary</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          272
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/272"> Closest Binary Search Tree Value II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          273
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/273"> Integer to English Words</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          282
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/282"> Expression Add Operators</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          295
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/295"> Find Median from Data Stream</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          296
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/296"> Best Meeting Point</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          297
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/297"> Serialize and Deserialize Binary Tree</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          301
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/301"> Remove Invalid Parentheses</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          302
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/302"> Smallest Rectangle Enclosing Black Pixels</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          305
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/305"> Number of Islands II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          308
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/308"> Range Sum Query 2D - Mutable</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          312
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/312"> Burst Balloons</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          315
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/315"> Count of Smaller Numbers After Self</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          317
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/317"> Shortest Distance from All Buildings</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          321
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/321"> Create Maximum Number</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          327
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/327"> Count of Range Sum</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          329
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/329"> Longest Increasing Path in a Matrix</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          330
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/330"> Patching Array</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          335
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/335"> Self Crossing</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          336
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/336"> Palindrome Pairs</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          352
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/352"> Data Stream as Disjoint Intervals</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          354
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/354"> Russian Doll Envelopes</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          358
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/358"> Rearrange String k Distance Apart</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          363
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/363"> Max Sum of Rectangle No Larger Than K</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          381
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/381"> Insert Delete GetRandom O(1) - Duplicates allowed</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          391
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/391"> Perfect Rectangle</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          403
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/403"> Frog Jump</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          407
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/407"> Trapping Rain Water II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          410
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/410"> Split Array Largest Sum</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          411
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/411"> Minimum Unique Word Abbreviation</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          420
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/420"> Strong Password Checker</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          425
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/425"> Word Squares</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          428
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/428"> Serialize and Deserialize N-ary Tree</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          431
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/431"> Encode N-ary Tree to Binary Tree</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          432
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/432"> All O`one Data Structure</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          440
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/440"> K-th Smallest in Lexicographical Order</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          446
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/446"> Arithmetic Slices II - Subsequence</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          458
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/458"> Poor Pigs</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          460
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/460"> LFU Cache</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          465
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/465"> Optimal Account Balancing</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          466
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/466"> Count The Repetitions</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          471
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/471"> Encode String with Shortest Length</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          472
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/472"> Concatenated Words</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          479
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/479"> Largest Palindrome Product</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          480
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/480"> Sliding Window Median</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          483
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/483"> Smallest Good Base</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          488
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/488"> Zuma Game</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          489
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/489"> Robot Room Cleaner</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          493
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/493"> Reverse Pairs</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          499
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/499"> The Maze III</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          502
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/502"> IPO</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          514
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/514"> Freedom Trail</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          517
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/517"> Super Washing Machines</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          527
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/527"> Word Abbreviation</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          546
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/546"> Remove Boxes</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          552
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/552"> Student Attendance Record II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          564
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/564"> Find the Closest Palindrome</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          568
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/568"> Maximum Vacation Days</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          587
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/587"> Erect the Fence</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          588
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/588"> Design In-Memory File System</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          591
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/591"> Tag Validator</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          600
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/600"> Non-negative Integers without Consecutive Ones</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          629
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/629"> K Inverse Pairs Array</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          630
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/630"> Course Schedule III</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          631
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/631"> Design Excel Sum Formula</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          632
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/632"> Smallest Range Covering Elements from K Lists</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          639
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/639"> Decode Ways II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          642
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/642"> Design Search Autocomplete System</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          644
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/644"> Maximum Average Subarray II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          656
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/656"> Coin Path</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          660
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/660"> Remove 9</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          664
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/664"> Strange Printer</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          668
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/668"> Kth Smallest Number in Multiplication Table</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          675
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/675"> Cut Off Trees for Golf Event</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          679
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/679"> 24 Game</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          683
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/683"> K Empty Slots</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          685
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/685"> Redundant Connection II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          689
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/689"> Maximum Sum of 3 Non-Overlapping Subarrays</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          691
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/691"> Stickers to Spell Word</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          699
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/699"> Falling Squares</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          710
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/710"> Random Pick with Blacklist</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          711
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/711"> Number of Distinct Islands II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          715
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/715"> Range Module</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          719
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/719"> Find K-th Smallest Pair Distance</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          726
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/726"> Number of Atoms</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          727
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/727"> Minimum Window Subsequence</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          730
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/730"> Count Different Palindromic Subsequences</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          732
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/732"> My Calendar III</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          736
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/736"> Parse Lisp Expression</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          741
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/741"> Cherry Pickup</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          745
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/745"> Prefix and Suffix Search</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          749
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/749"> Contain Virus</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          753
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/753"> Cracking the Safe</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          757
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/757"> Set Intersection Size At Least Two</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          759
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/759"> Employee Free Time</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          761
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/761"> Special Binary String</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          765
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/765"> Couples Holding Hands</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          768
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/768"> Max Chunks To Make Sorted II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          770
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/770"> Basic Calculator IV</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          772
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/772"> Basic Calculator III</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          773
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/773"> Sliding Puzzle</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          774
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/774"> Minimize Max Distance to Gas Station</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          778
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/778"> Swim in Rising Water</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          780
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/780"> Reaching Points</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          782
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/782"> Transform to Chessboard</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          786
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/786"> K-th Smallest Prime Fraction</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          793
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/793"> Preimage Size of Factorial Zeroes Function</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          798
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/798"> Smallest Rotation with Highest Score</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          803
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/803"> Bricks Falling When Hit</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          805
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/805"> Split Array With Same Average</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          810
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/810"> Chalkboard XOR Game</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          815
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/815"> Bus Routes</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          818
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/818"> Race Car</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          827
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/827"> Making A Large Island</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          828
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/828"> Count Unique Characters of All Substrings of a Given String</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          829
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/829"> Consecutive Numbers Sum</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          834
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/834"> Sum of Distances in Tree</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          839
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/839"> Similar String Groups</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          843
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/843"> Guess the Word</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          847
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/847"> Shortest Path Visiting All Nodes</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          850
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/850"> Rectangle Area II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          854
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/854"> K-Similar Strings</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          857
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/857"> Minimum Cost to Hire K Workers</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          862
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/862"> Shortest Subarray with Sum at Least K</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          864
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/864"> Shortest Path to Get All Keys</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          871
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/871"> Minimum Number of Refueling Stops</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          878
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/878"> Nth Magical Number</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          879
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/879"> Profitable Schemes</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          882
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/882"> Reachable Nodes In Subdivided Graph</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          887
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/887"> Super Egg Drop</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          891
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/891"> Sum of Subsequence Widths</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          895
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/895"> Maximum Frequency Stack</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          899
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/899"> Orderly Queue</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          902
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/902"> Numbers At Most N Given Digit Set</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          903
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/903"> Valid Permutations for DI Sequence</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          906
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/906"> Super Palindromes</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          913
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/913"> Cat and Mouse</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          920
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/920"> Number of Music Playlists</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          924
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/924"> Minimize Malware Spread</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          927
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/927"> Three Equal Parts</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          928
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/928"> Minimize Malware Spread II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          936
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/936"> Stamping The Sequence</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          940
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/940"> Distinct Subsequences II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          943
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/943"> Find the Shortest Superstring</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          952
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/952"> Largest Component Size by Common Factor</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          956
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/956"> Tallest Billboard</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          960
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/960"> Delete Columns to Make Sorted III</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          964
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/964"> Least Operators to Express Number</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          968
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/968"> Binary Tree Cameras</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          972
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/972"> Equal Rational Numbers</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          975
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/975"> Odd Even Jump</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          980
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/980"> Unique Paths III</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          982
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/982"> Triples with Bitwise AND Equal To Zero</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          987
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/987"> Vertical Order Traversal of a Binary Tree</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          992
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/992"> Subarrays with K Different Integers</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          995
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/995"> Minimum Number of K Consecutive Bit Flips</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          996
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/996"> Number of Squareful Arrays</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1000
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1000"> Minimum Cost to Merge Stones</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1001
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1001"> Grid Illumination</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1012
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1012"> Numbers With Repeated Digits</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1028
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1028"> Recover a Tree From Preorder Traversal</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1032
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1032"> Stream of Characters</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1036
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1036"> Escape a Large Maze</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1044
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1044"> Longest Duplicate Substring</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1063
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1063"> Number of Valid Subarrays</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1067
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1067"> Digit Count in Range</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1074
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1074"> Number of Submatrices That Sum to Target</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1088
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1088"> Confusing Number II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1092
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1092"> Shortest Common Supersequence </a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1095
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1095"> Find in Mountain Array</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1096
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1096"> Brace Expansion II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1106
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1106"> Parsing A Boolean Expression</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1121
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1121"> Divide Array Into Increasing Sequences</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1125
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1125"> Smallest Sufficient Team</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1147
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1147"> Longest Chunked Palindrome Decomposition</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1153
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1153"> String Transforms Into Another String</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1157
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1157"> Online Majority Element In Subarray</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1163
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1163"> Last Substring in Lexicographical Order</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1168
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1168"> Optimize Water Distribution in a Village</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1172
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1172"> Dinner Plate Stacks</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1178
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1178"> Number of Valid Words for Each Puzzle</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1183
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1183"> Maximum Number of Ones</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1187
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1187"> Make Array Strictly Increasing</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1192
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1192"> Critical Connections in a Network</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1199
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1199"> Minimum Time to Build Blocks</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1203
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1203"> Sort Items by Groups Respecting Dependencies</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1206
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1206"> Design Skiplist</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1210
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1210"> Minimum Moves to Reach Target with Rotations</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1216
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1216"> Valid Palindrome III</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1220
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1220"> Count Vowels Permutation</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1223
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1223"> Dice Roll Simulation</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1224
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1224"> Maximum Equal Frequency</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1231
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1231"> Divide Chocolate</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1235
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1235"> Maximum Profit in Job Scheduling</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1240
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1240"> Tiling a Rectangle with the Fewest Squares</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1246
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1246"> Palindrome Removal</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1250
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1250"> Check If It Is a Good Array</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1255
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1255"> Maximum Score Words Formed by Letters</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1259
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1259"> Handshakes That Don&#x27;t Cross</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1263
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1263"> Minimum Moves to Move a Box to Their Target Location</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1269
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1269"> Number of Ways to Stay in the Same Place After Some Steps</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1274
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1274"> Number of Ships in a Rectangle</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1278
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1278"> Palindrome Partitioning III</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1284
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1284"> Minimum Number of Flips to Convert Binary Matrix to Zero Matrix</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1289
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1289"> Minimum Falling Path Sum II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1293
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1293"> Shortest Path in a Grid with Obstacles Elimination</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1298
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1298"> Maximum Candies You Can Get from Boxes</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1301
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1301"> Number of Paths with Max Score</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1307
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1307"> Verbal Arithmetic Puzzle</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1312
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1312"> Minimum Insertion Steps to Make a String Palindrome</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1316
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1316"> Distinct Echo Substrings</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1320
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1320"> Minimum Distance to Type a Word Using Two Fingers</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1326
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1326"> Minimum Number of Taps to Open to Water a Garden</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1330
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1330"> Reverse Subarray To Maximize Array Value</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1335
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1335"> Minimum Difficulty of a Job Schedule</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1340
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1340"> Jump Game V</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1345
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1345"> Jump Game IV</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1349
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1349"> Maximum Students Taking Exam</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1354
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1354"> Construct Target Array With Multiple Sums</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1359
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1359"> Count All Valid Pickup and Delivery Options</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1363
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1363"> Largest Multiple of Three</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1368
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1368"> Minimum Cost to Make at Least One Valid Path in a Grid</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1373
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1373"> Maximum Sum BST in Binary Tree</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1377
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1377"> Frog Position After T Seconds</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1383
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1383"> Maximum Performance of a Team</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1388
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1388"> Pizza With 3n Slices</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1392
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1392"> Longest Happy Prefix</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1397
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1397"> Find All Good Strings</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1402
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1402"> Reducing Dishes</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1406
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1406"> Stone Game III</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1411
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1411"> Number of Ways to Paint N × 3 Grid</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1416
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1416"> Restore The Array</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1420
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1420"> Build Array Where You Can Find The Maximum Exactly K Comparisons</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1425
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1425"> Constrained Subsequence Sum</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1434
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1434"> Number of Ways to Wear Different Hats to Each Other</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1439
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1439"> Find the Kth Smallest Sum of a Matrix With Sorted Rows</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1444
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1444"> Number of Ways of Cutting a Pizza</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1449
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1449"> Form Largest Integer With Digits That Add up to Target</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1453
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1453"> Maximum Number of Darts Inside of a Circular Dartboard</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1458
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1458"> Max Dot Product of Two Subsequences</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1463
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1463"> Cherry Pickup II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1467
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1467"> Probability of a Two Boxes Having The Same Number of Distinct Balls</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1473
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1473"> Paint House III</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1478
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1478"> Allocate Mailboxes</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1483
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1483"> Kth Ancestor of a Tree Node</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1489
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1489"> Find Critical and Pseudo-Critical Edges in Minimum Spanning Tree</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1494
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1494"> Parallel Courses II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1499
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1499"> Max Value of Equation</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1505
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1505"> Minimum Possible Integer After at Most K Adjacent Swaps On Digits</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1510
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1510"> Stone Game IV</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1515
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1515"> Best Position for a Service Centre</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1516
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1516"> Move Sub-Tree of N-Ary Tree</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1520
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1520"> Maximum Number of Non-Overlapping Substrings</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1521
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1521"> Find a Value of a Mysterious Function Closest to Target</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1526
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1526"> Minimum Number of Increments on Subarrays to Form a Target Array</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1531
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1531"> String Compression II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1537
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1537"> Get the Maximum Score</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1542
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1542"> Find Longest Awesome Substring</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1547
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1547"> Minimum Cost to Cut a Stick</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1548
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1548"> The Most Similar Path in a Graph</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1553
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1553"> Minimum Number of Days to Eat N Oranges</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1559
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1559"> Detect Cycles in 2D Grid</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1563
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1563"> Stone Game V</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1568
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1568"> Minimum Number of Days to Disconnect Island</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1569
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1569"> Number of Ways to Reorder Array to Get Same BST</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1575
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1575"> Count All Possible Routes</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1579
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1579"> Remove Max Number of Edges to Keep Graph Fully Traversable</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1585
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1585"> Check If String Is Transformable With Substring Sort Operations</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1591
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1591"> Strange Printer II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1595
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1595"> Minimum Cost to Connect Two Groups of Points</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1597
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1597"> Build Binary Expression Tree From Infix Expression</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1601
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1601"> Maximum Number of Achievable Transfer Requests</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1606
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1606"> Find Servers That Handled Most Number of Requests</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1610
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1610"> Maximum Number of Visible Points</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1611
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1611"> Minimum One Bit Operations to Make Integers Zero</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1617
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1617"> Count Subtrees With Max Distance Between Cities</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1622
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1622"> Fancy Sequence</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1627
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1627"> Graph Connectivity With Threshold</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1632
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1632"> Rank Transform of a Matrix</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1639
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1639"> Number of Ways to Form a Target String Given a Dictionary</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1643
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1643"> Kth Smallest Instructions</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1649
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1649"> Create Sorted Array through Instructions</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1655
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1655"> Distribute Repeating Integers</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1659
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1659"> Maximize Grid Happiness</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1665
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1665"> Minimum Initial Energy to Finish Tasks</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1671
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1671"> Minimum Number of Removals to Make Mountain Array</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1675
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1675"> Minimize Deviation in Array</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1681
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1681"> Minimum Incompatibility</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1687
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1687"> Delivering Boxes from Storage to Ports</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1691
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1691"> Maximum Height by Stacking Cuboids </a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1692
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1692"> Count Ways to Distribute Candies</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1697
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1697"> Checking Existence of Edge Length Limited Paths</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1703
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1703"> Minimum Adjacent Swaps for K Consecutive Ones</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1707
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1707"> Maximum XOR With an Element From Array</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1713
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1713"> Minimum Operations to Make a Subsequence</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1714
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1714"> Sum Of Special Evenly-Spaced Elements In Array</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1719
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1719"> Number Of Ways To Reconstruct A Tree</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1723
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1723"> Find Minimum Time to Finish All Jobs</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1724
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1724"> Checking Existence of Edge Length Limited Paths II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1728
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1728"> Cat and Mouse II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1735
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1735"> Count Ways to Make Array With Product</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1739
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1739"> Building Boxes</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1745
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1745"> Palindrome Partitioning IV</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1751
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1751"> Maximum Number of Events That Can Be Attended II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1755
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1755"> Closest Subsequence Sum</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1761
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1761"> Minimum Degree of a Connected Trio in a Graph</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1766
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1766"> Tree of Coprimes</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1771
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1771"> Maximize Palindrome Length From Subsequences</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1776
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1776"> Car Fleet II</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1782
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1782"> Count Pairs Of Nodes</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1787
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1787"> Make the XOR of All Segments Equal to Zero</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1788
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1788"> Maximize the Beauty of the Garden</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1793
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1793"> Maximum Score of a Good Subarray</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1799
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1799"> Maximize Score After N Operations</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1803
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1803"> Count Pairs With XOR in a Range</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1808
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1808"> Maximize Number of Nice Divisors</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1815
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1815"> Maximum Number of Groups Getting Fresh Donuts</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1819
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1819"> Number of Different Subsequences GCDs</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1825
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1825"> Finding MK Average</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1830
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1830"> Minimum Number of Operations to Make String Sorted</a>
        </td>
        <td>Hard</td>
      </tr>
      <tr>
        <td>
          1835
        </td>
        <td>
          <a href="http://rustgym.com/leetcode/1835"> Find XOR Sum of All Pairs Bitwise AND</a>
        </td>
        <td>Hard</td>
      </tr></tbody>
</table>

<table id="adventofcode" class="table-auto">
  <thead>
    <tr>
      <th>Year</th>
      <th>Day</th>
      <th>AdventOfCode</th>
    </tr>
  </thead>
  <tbody>
      <tr>
        <td>
          2015
        </td>
        <td>
          1
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/201501"> Not Quite Lisp</a>
        </td>
      </tr>
      <tr>
        <td>
          2015
        </td>
        <td>
          2
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/201502"> I Was Told There Would Be No Math</a>
        </td>
      </tr>
      <tr>
        <td>
          2015
        </td>
        <td>
          3
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/201503"> Perfectly Spherical Houses in a Vacuum</a>
        </td>
      </tr>
      <tr>
        <td>
          2015
        </td>
        <td>
          4
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/201504"> The Ideal Stocking Stuffer</a>
        </td>
      </tr>
      <tr>
        <td>
          2015
        </td>
        <td>
          5
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/201505"> Doesn&#x27;t He Have Intern-Elves For This?</a>
        </td>
      </tr>
      <tr>
        <td>
          2015
        </td>
        <td>
          6
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/201506"> Probably a Fire Hazard</a>
        </td>
      </tr>
      <tr>
        <td>
          2015
        </td>
        <td>
          7
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/201507"> Some Assembly Required</a>
        </td>
      </tr>
      <tr>
        <td>
          2015
        </td>
        <td>
          8
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/201508"> Matchsticks</a>
        </td>
      </tr>
      <tr>
        <td>
          2015
        </td>
        <td>
          9
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/201509"> All in a Single Night</a>
        </td>
      </tr>
      <tr>
        <td>
          2015
        </td>
        <td>
          10
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/201510"> Elves Look, Elves Say</a>
        </td>
      </tr>
      <tr>
        <td>
          2015
        </td>
        <td>
          11
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/201511"> Corporate Policy</a>
        </td>
      </tr>
      <tr>
        <td>
          2015
        </td>
        <td>
          12
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/201512"> JSAbacusFramework.io</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          1
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202001"> Report Repair</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          2
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202002"> Password Philosophy</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          3
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202003"> Toboggan Trajectory</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          4
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202004"> Passport Processing</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          5
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202005"> Binary Boarding</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          6
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202006"> Custom Customs</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          7
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202007"> Handy Haversacks</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          8
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202008"> Handheld Halting</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          9
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202009"> Encoding Error</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          10
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202010"> Adapter Array</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          11
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202011"> Seating System</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          12
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202012"> Rain Risk</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          13
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202013"> Shuttle Search</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          14
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202014"> Docking Data</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          15
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202015"> Rambunctious Recitation</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          16
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202016"> Ticket Translation</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          17
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202017"> Conway Cubes</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          18
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202018"> Operation Order</a>
        </td>
      </tr>
      <tr>
        <td>
          2020
        </td>
        <td>
          19
        </td>
        <td>
          <a href="http://rustgym.com/adventofcode/202019"> Monster Messages</a>
        </td>
      </tr></tbody>
</table>

<table id="google" class="table-auto">
  <thead>
    <tr>
      <th>Division</th>
      <th>Year</th>
      <th>Round</th>
      <th>Google</th>
    </tr>
  </thead>
  <tbody>
      <tr>
        <td>CodeJam</td>
        <td>
          2008
        </td>
        <td>
          1
        </td>
        <td>
          <a href="http://rustgym.com/google/120080101"> fly swatter</a>
        </td>
      </tr>
      <tr>
        <td>KickStart</td>
        <td>
          2013
        </td>
        <td>
          1
        </td>
        <td>
          <a href="http://rustgym.com/google/220130101"> moist</a>
        </td>
      </tr>
      <tr>
        <td>KickStart</td>
        <td>
          2013
        </td>
        <td>
          1
        </td>
        <td>
          <a href="http://rustgym.com/google/220130102"> captain hammer</a>
        </td>
      </tr>
      <tr>
        <td>KickStart</td>
        <td>
          2013
        </td>
        <td>
          1
        </td>
        <td>
          <a href="http://rustgym.com/google/220130103"> bad horse</a>
        </td>
      </tr>
      <tr>
        <td>KickStart</td>
        <td>
          2020
        </td>
        <td>
          1
        </td>
        <td>
          <a href="http://rustgym.com/google/220200101"> allocation</a>
        </td>
      </tr>
      <tr>
        <td>KickStart</td>
        <td>
          2021
        </td>
        <td>
          1
        </td>
        <td>
          <a href="http://rustgym.com/google/220210101"> k goodness string</a>
        </td>
      </tr>
      <tr>
        <td>KickStart</td>
        <td>
          2021
        </td>
        <td>
          1
        </td>
        <td>
          <a href="http://rustgym.com/google/220210102"> l shaped plots</a>
        </td>
      </tr>
      <tr>
        <td>KickStart</td>
        <td>
          2021
        </td>
        <td>
          1
        </td>
        <td>
          <a href="http://rustgym.com/google/220210103"> rabbit house</a>
        </td>
      </tr>
      <tr>
        <td>KickStart</td>
        <td>
          2021
        </td>
        <td>
          1
        </td>
        <td>
          <a href="http://rustgym.com/google/220210104"> checksum</a>
        </td>
      </tr></tbody>
</table>